unit FilterNode;



(**********************************************************)

                        interface

(**********************************************************)
uses Classes;

type

  //transforms take place on selected node
  //what role it plays ?
  TWhereToAdd=(wtaToNode{add set to node},
               wtaAsSibling{selected node is subling of new node},
               wtaAsChild{selected node is parent of new node});
  TNodeType=(ntStateNode,ntBranchNode);

  TCharSet=set of char;



  PFilterNode=^TFilterNode;
  TFilterNode=class(TObject)
  private
      FValidChars:TCharSet;
      
  public
      FNodeType:TNodeType;
      constructor create(NodeType:TNodeType);
      procedure getCaption(out s:string);
      procedure addSet(const s:TCharSet);
      function  anyCommon(const s:TCharSet):boolean;
      procedure  getValidChars(out s:TCharSet);
      procedure saveToStream(s:TStream);
      procedure loadFromStream(s:TStream);
  end;

(**********************************************************)

                    implementation

(**********************************************************)

procedure TFilterNode.saveToStream(s:TStream);
begin
  s.Write(FValidChars,sizeof(FValidChars));
  s.Write(FNodeType, sizeof(FNodeType));
end;
{----------------------------------------------------------}
procedure TFilterNode.loadFromStream(s:TStream);
begin
 s.Read(FValidChars, sizeof(FValidChars));
 s.Read(FNodeType, sizeof(FNodeType));
end;
{----------------------------------------------------------}

constructor TFilterNode.create(NodeType:TNodeType);
begin
    FNodeType:=NodeType;
    FValidChars:=[];
end;
{----------------------------------------------------------}
function TFilterNode.anyCommon(const s:TCharSet):boolean;
begin
    result:=(FValidChars*s<>[]);
end;
{----------------------------------------------------------}
procedure  TFilterNode.getValidChars(out s:TCharSet);
begin
    s:=FValidChars;
end;
{----------------------------------------------------------}
procedure TFilterNode.addSet(const s:TCharSet);
begin
  if not  anyCommon(s) then
       FValidChars:=FValidChars+s;
end;
{----------------------------------------------------------}
procedure TFilterNode.getCaption(out s:string);
var i:integer;
    c:char;
begin
     if FNodeType=ntStateNode then s:='[S]: '
     else s:='';
     for c:=low(char) to high(char) do
          if c in FValidChars then
              s:=s+c+' ';
end;
{----------------------------------------------------------}

end.


