////////////////////////////////////////////////////////////
//  TFilteredEdit.pas 2007/09/18 20:40:20                 //
//  component for protected input                         //
//  @author  Dmitriy Kim <DmitriyKim@inbox.ru>            //
//  @version 1.0                                          //
////////////////////////////////////////////////////////////

unit FilteredEdit;

(**********************************************************)

                        interface

(**********************************************************)

uses
  Classes, Controls, StdCtrls, Filter, Forms,ExtCtrls, ComCtrls;

type
  TFilteredEdit = class(TGroupBox)
  private
    FTimer:TTimer;  // TFilteredEdit.create


    procedure WriteData(s:TStream);
    procedure ReadData(s:TStream);
    function getText:string;


  protected
    procedure DefineProperties(Filer: TFiler); override;


  public
      FFilter:TFilter;
      destructor destroy;override;
      constructor  create(AOwner:TComponent); override;

      property Text:string read getText;
      function terminated:boolean;
  end;


(**********************************************************)

                    implementation

(**********************************************************)
uses Dialogs;

procedure TFilteredEdit.ReadData(s:TStream);
begin
      FFilter.loadFromStream(s);
end;
{----------------------------------------------------------}
procedure TFilteredEdit.WriteData(s:TStream);
begin
    FFilter.saveToStream(s);
end;
{----------------------------------------------------------}
procedure TFilteredEdit.DefineProperties(Filer: TFiler);
begin
    inherited DefineProperties(Filer);

    Filer.DefineBinaryProperty('FiltereredEdit',ReadData,WriteData,true);
end;
{----------------------------------------------------------}
function TFilteredEdit.getText:string;
begin
  result:=FFilter.FEdit.Text;
end;
{----------------------------------------------------------}
function TFilteredEdit.terminated:boolean;
//is input terminated ?
begin
  result:=FFilter.terminated;
end;

{----------------------------------------------------------}
constructor  TFilteredEdit.create(AOwner:TComponent);
begin
   inherited create(AOwner);
   FFilter:=TFilter.Create(Application,self);
{
   first in constructor  TFilter.Create
   was line
        FTreeView.Items.AddObjectFirst(nil,s,firstNode)//needed
                                                       //for filter logic
   Every time the error occurred on this line:
               'component has no parent window',
   because by now  TFilteredEdit was not completely constructed.
   FTreeView.Items.beginUpdate did not help.
   Temp solution:  FTreeView.Items.AddObjectFirst(nil,s,firstNode)
   is carried out into  TFilter.init,  which is called through FTimer.OnTimer
   If somebody knows elegant solution please contact author
}

   FTimer:=TTimer.Create(self);
   FTimer.Interval:=300;
   FTimer.OnTimer:=FFilter.init;
   FTimer.Enabled:=true;
end;
{----------------------------------------------------------}
destructor TFilteredEdit.destroy;
begin
  FFilter.Free;
  inherited destroy;
end;
{----------------------------------------------------------}
end.
